;*** RFM12BP.inc ***;
;------------------------------------------------
; Author: Torsten Knorr
; E-mail: create-soft@freenet.de
; copyright(C) 2016-2017 by Torsten Knorr
;------------------------------------------------

 .ifndef __RFM12BP__
 .equ    __RFM12BP__ = 1

;------------------------------------------------

 .def    R_MUL_L        = R0
 .def    R_MUL_H        = R1
 .def    RI_TEMP_L      = R2
 .def    RI_TEMP_H      = R3
 .def    R_DATA_L       = R4
 .def    R_DATA_H       = R5
 .def    R_T2_COUNT     = R6
 .def    R_TEST         = R7
 .def    R_RXW_L        = R8
 .def    R_RXW_H        = R9
 .def    RI_XP_END_L    = R10
 .def    RI_XP_END_H    = R11
 .def    RI_YP_END_L    = R12
 .def    RI_YP_END_H    = R13
 .def    RI_SREG        = R14
 .def    RI_SPSR        = R15
 .def    R_TEMP_L       = R16
 .def    R_TEMP_H       = R17
 .def    RI_TX_BYTE     = R18
 .def    RI_RX_BYTE     = R19
 .def    RI_TWI         = R20
 .def    R_FREE_USE     = R21
 .def    R_PARA_L       = R22
 .def    R_PARA_H       = R23
 .def    R_COUNT_L      = R24
 .def    R_COUNT_H      = R25

 .undef  XL
 .def    RI_XP_RTX_L    = R26
 .undef  XH
 .def    RI_XP_RTX_H    = R27

 .undef  YL
 .def    RI_YP_TWI_L    = R28
 .undef  YH
 .def    RI_YP_TWI_H    = R29

 .undef  ZL
 .def    R_ZP_L         = R30
 .undef  ZH
 .def    R_ZP_H         = R31

;------------------------------------------------

 .equ    LED_TX         = PORTB0
 .equ    RFM12BP_nRES   = PORTB1
 .equ    SPI_SS         = PORTB2
 .equ    SPI_MOSI       = PORTB3
 .equ    SPI_MISO       = PORTB4
 .equ    SPI_SCK        = PORTB5
 ;.equ   XTAL1          = PORTB6
 ;.equ   XTAL2          = PORTB7

 .equ    SPI_DDR_PORT   = DDRB
 .equ    SPI_PORT       = PORTB

 ;.equ   unused         = PORTC0
 .equ    RFM12BP_EN_TX  = PORTC1
 .equ    RFM12BP_EN_RX  = PORTC2
 .equ    LED_RX         = PORTC3
 .equ    SDA            = PORTC4
 .equ    SCL            = PORTC5
 .equ    MC_RESET       = PORTC6

 .equ    LED_LISTEN     = PORTD0
 .equ    LED_RUN        = PORTD1
 .equ    RFM12BP_SDO    = PORTD2 ; INT0
 .equ    RFM12BP_FFIT   = PORTD3 ; INT1
 .equ    RFM12BP_VDI    = PORTD4 ; PCINT20
 .equ    LED_VDI        = PORTD5
 .equ    LED_DEBUG_1    = PORTD6
 .equ    LED_DEBUG_2    = PORTD7

 .equ    STATUS_REG     = GPIOR0
 .equ    TWI_BUSY_BIT   = GPIOR00
 .equ    TWI_REQUEST    = GPIOR01
 .equ    TIMER_1_RUN    = GPIOR02
 .equ    TIMER_2_RUN    = GPIOR03
 .equ    VDI_STAT_OK    = GPIOR04
 .equ    FFIT_RGIT      = GPIOR05
 .equ    NEW_INIT       = GPIOR06
 .equ    BIT_7_UNUSED   = GPIOR07

 .equ    TX_CONFIG_1    = GPIOR1
 .equ    TX_CONFIG_2    = GPIOR2

 .equ    INT1_EN_RX     = INT1
 .equ    INT0_EN_TX     = INT0
 .equ    PCINT20_VDI    = PCINT20

 .equ    TWI_SLAVE_ADDR = (0x71 << 1)

;------------------------------------------------

 .equ    BYTES_PRE_SIG  = 0x04

 .equ    BYTES_PREAMBLE = 0x0A
 .equ    BYTES_FR_START = 0x02
 .equ    BYTES_ID       = 0x04
 .equ    BYTES_TIME     = 0x06
 .equ    BYTES_CMD      = 0x01
 .equ    BYTES_PARA     = 0x02
 .equ    BYTES_FINALE   = 0x06

 .equ    BYTES_DATA     = 0x40
 .equ    BYTES_CRC      = 0x01

 .equ    RX_REQUEST_SIZE  = (BYTES_ID + BYTES_TIME + BYTES_CMD + BYTES_PARA)
 .equ    TX_REQUEST_SIZE  = (BYTES_PREAMBLE + BYTES_FR_START + RX_REQUEST_SIZE + BYTES_FINALE)

 .equ    RX_RESPONSE_SIZE = (BYTES_ID + BYTES_TIME + BYTES_CMD + BYTES_PARA + BYTES_DATA + BYTES_CRC)
 .equ    TX_RESPONSE_SIZE = (BYTES_PREAMBLE + BYTES_FR_START + RX_RESPONSE_SIZE + BYTES_FINALE)

 .equ    TX_BEGIN_SIZE  = (BYTES_PREAMBLE + BYTES_FR_START)

 .equ    FRAME_START_H  = 0x2D
 .equ    FRAME_START_L  = 0x99
 .equ    ID_BYTE_1      = 192
 .equ    ID_BYTE_2      = 168
 .equ    ID_BYTE_3      = 100
 .equ    ID_BYTE_4      = 001

;------------------------------------------------

 .eseg
 .org 0x00
 e_request:
 e_preamble:    .db 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA
 e_frame_start: .db FRAME_START_H, FRAME_START_L
 e_identifier:  .db ID_BYTE_1, ID_BYTE_2, ID_BYTE_3, ID_BYTE_4
 e_time:        .db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
 e_cmd:         .db 0x00
 e_para:        .db 0x00, 0x00
 e_finale:      .db 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA
 e_request_end:

; low byte first!
 e_configure:
 e_cmd_set_conf:     .dw (CMD_SET_CONF   | CAPACITOR_12_5  | EN_TX_REG  | EN_RX_BUF | FREQ_BAND_868)
 e_cmd_set_power:    .dw (CMD_SET_POWER  | EN_CRYSTAL      | DI_CLK_PIN | EN_SYNTH)
 e_cmd_set_freq:     .dw (CMD_SET_FREQ   | FREQ_869_525)
 e_cmd_set_br:       .dw (CMD_SET_BR     | BIT_RATE_1_2)
 e_cmd_rx_config:    .dw (CMD_RX_CONFIG  | BAND_WIDTH_134  | PIN_16_VDI | DRSSI_103 | VDI_SLOW | LNA_GAIN_0)
 e_cmd_set_filter:   .dw (CMD_SET_FILTER | CLK_REC_AUTO    | DIG_FILTER | DQD_7)
 e_cmd_fifo_reset:   .dw (CMD_FIFO_RESET | FIFO_SYNC_WORD  | EN_HI_SENS | FIFO_INT_LEVEL_8)
 e_cmd_sync_pat:     .dw (CMD_SYNC_PAT   | FRAME_START_L)
 e_cmd_afc:          .dw (CMD_AFC        | EN_AFC_ACCURACY | EN_AFC_REG | AFC_INDEPEND | EN_AFC_FUNC)
 e_cmd_tx_config:    .dw (CMD_TX_CONFIG  | OUTPUT_POWER_9  | FREQ_DEVIATION_30 )
 e_cmd_set_pll:      .dw (CMD_SET_PLL    | DI_DITHERING_PLL)
 e_cmd_wake_up_time: .dw (CMD_WAKE_UP_TIME) ; disable
 e_cmd_low_duty:     .dw (CMD_LOW_DUTY)     ; disable
 e_cmd_batt_clk_div: .dw (CMD_BATT_CLK_DIV) ; disable
 e_configure_end:

 e_tx_config_1:      .db low(OUTPUT_POWER_6 | FREQ_DEVIATION_45)
 e_tx_config_2:      .db low(OUTPUT_POWER_9 | FREQ_DEVIATION_30)

 e_temp_address:     .db e_end
 e_temp_value_l:     .db 0x00
 e_temp_value_h:     .db 0x00

 e_debug:
 e_test_1:           .db 0x12
 e_test_2:           .db 0x34
 e_test_3:           .db 0x56

 e_end:

;-------------------------------------------------

 .macro M_PROGRAM_START

; Set Stack Pointer to top of RAM
    ldi  R_TEMP_H,      high(RAMEND)
    ldi  R_TEMP_L,      low(RAMEND)
    out  SPH,           R_TEMP_H
    out  SPL,           R_TEMP_L

; enable global interrupts
    sei

 .endmacro

;------------------------------------------------

 .macro M_INIT_WATCHDOG

    wdr
; set prescaler(time-out) 8 sec.
    ldi  R_TEMP_H,      ((1 << WDE) | (1 << WDP3) | (1 << WDP0))

; Start timed sequence
    lds  R_TEMP_L,      WDTCSR

; set WatchdogChangeEnable and WatchDogEnable bit in register
    ori  R_TEMP_L,      ((1 << WDCE) | (1 << WDE))

; enable watchdog change
    sts  WDTCSR,        R_TEMP_L

; got four cycles to set the new values from here
    sts  WDTCSR,        R_TEMP_H

; finished setting new values, used 2 cycles
    wdr

 .endmacro

;------------------------------------------------

.macro M_INIT_PORTS

; TWI Ports
    cbi  DDRC,          DDC4
    cbi  DDRC,          DDC5
; pull up's on
    sbi  PORTC,         SCL
    sbi  PORTC,         SDA

    sbi  DDRB,          DDB0
    cbi  PORTB,         LED_TX

; configure PortB1 as output for RFM12_nRES
    sbi  DDRB,          DDB1
; reset RFM12BP modul
    cbi  PORTB,         RFM12BP_nRES

; set ports to output for SPI MOSI SCK SS
    sbi  SPI_DDR_PORT,  SPI_MOSI
    cbi  SPI_PORT,      SPI_MOSI

    sbi  SPI_DDR_PORT,  SPI_SCK
    cbi  SPI_PORT,      SPI_SCK

    sbi  SPI_DDR_PORT,  SPI_SS
    sbi  SPI_PORT,      SPI_SS

; set port to input for SPI MISO
    cbi  SPI_DDR_PORT,  SPI_MISO
; pull up on
    sbi  SPI_PORT,      SPI_MISO

    sbi  DDRC,          PORTC0
    cbi  PORTC,         PORTC0

; configure PortC1 as output for transmit enable
    sbi  DDRC,          RFM12BP_EN_TX
    cbi  PORTC,         RFM12BP_EN_TX

; configure PortC2 as output for receive enable
    sbi  DDRC,          RFM12BP_EN_RX
    cbi  PORTC,         RFM12BP_EN_RX

    sbi  DDRC,          PORTC3
    cbi  PORTC,         LED_RX

    cbi  DDRC,          DDC6
    sbi  PORTC,         MC_RESET

; LED_LISTEN
    sbi  DDRD,          DDD0
    cbi  PORTD,         LED_LISTEN

; LED_RUN
    sbi  DDRD,          DDD1
    cbi  PORTD,         LED_RUN

; configure PORTD2 as input for INT0 transmit
    cbi  DDRD,          DDD2
; pull up on
    sbi  PORTD,         RFM12BP_SDO

; configure PORTD3 as input for INT1 receive
    cbi  DDRD,          DDD3
; pull up on
    sbi  PORTD,         RFM12BP_FFIT

; configure PORTD4 as input for PCINT20 VDI
    cbi  DDRD,          DDD4
; pull up on
    sbi  PORTD,         RFM12BP_VDI

; set ports as output for LEDs
    sbi  DDRD,          DDD5
    cbi  PORTD,         LED_VDI

    sbi  DDRD,          DDD6
    cbi  PORTD,         LED_DEBUG_1

    sbi  DDRD,          DDD7
    cbi  PORTD,         LED_DEBUG_2

 .endmacro

;------------------------------------------------

 .macro M_INIT_SRAM

    wdr
; number of bytes
    ldi  R_COUNT_L,      @0

; SRAM address
    ldi  R_ZP_L,        low(@1)
    ldi  R_ZP_H,        high(@1)

; EEPROM address
    ldi  R_COUNT_H,     low(@2)

; Wait for completion of previous write
 INIT_SRAM_WAIT_EEPROM_WRITE:
    sbic EECR,EEPE
    rjmp INIT_SRAM_WAIT_EEPROM_WRITE

 INIT_SRAM_LOOP:

; Set up address in address register
    out  EEARL,         R_COUNT_H

; Start eeprom read by writing EERE
    sbi  EECR,          EERE

; Read data from Data Register
    in   R_TEMP_L,      EEDR

    st   Z+,            R_TEMP_L

    inc  R_COUNT_H
    dec  R_COUNT_L
    brne INIT_SRAM_LOOP

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_INIT

; reset RFM12BP
    cbi  PORTB,         RFM12BP_nRES
    M_SET_TIMER_1 TIME_200MS
    M_WAIT_TIMER_1

    sbi  PORTB,         RFM12BP_nRES
    M_SET_TIMER_1 TIME_200MS
    M_WAIT_TIMER_1

; EEPROM address start
    ldi  R_COUNT_L,     e_configure

; EEPROM address end
    ldi  R_COUNT_H,     e_configure_end

; Wait for completion of previous write
 RFM12BP_INIT_WAIT_EEPROM_WRITE:
    sbic EECR,EEPE
    rjmp RFM12BP_INIT_WAIT_EEPROM_WRITE

 INIT_RFM12BP_INIT_LOOP:

; Set up address in address register
    out  EEARL,         R_COUNT_L
; Start eeprom read by writing EERE
    sbi  EECR,          EERE
; Read data from Data Register
    in   R_TEMP_L,      EEDR

    inc  R_COUNT_L
; Set up address in address register
    out  EEARL,         R_COUNT_L
; Start eeprom read by writing EERE
    sbi  EECR,          EERE
; Read data from Data Register
    in   R_TEMP_H,      EEDR

    M_SPI_TRANSFER

    inc  R_COUNT_L
                ; op < op
    cp   R_COUNT_L,     R_COUNT_H
    brlo INIT_RFM12BP_INIT_LOOP

; Set up address in address register
    out  EEARL,         R_COUNT_L
; Start eeprom read by writing EERE
    sbi  EECR,          EERE
; Read data from Data Register
    in   R_TEMP_L,      EEDR
    out  TX_CONFIG_1,   R_TEMP_L

    inc  R_COUNT_L
; Set up address in address register
    out  EEARL,         R_COUNT_L
; Start eeprom read by writing EERE
    sbi  EECR,          EERE
; Read data from Data Register
    in   R_TEMP_L,      EEDR
    out  TX_CONFIG_2,   R_TEMP_L

    clr  R_TEMP_L
    out  STATUS_REG,    R_TEMP_L

    sts  s_cmd,         R_TEMP_L

    ldi  R_TEMP_H,      e_temp_value_l
    rcall EEPROM_WRITE_BYTE

    ldi  R_TEMP_H,      e_temp_value_h
    rcall EEPROM_WRITE_BYTE

    ldi  R_TEMP_L,      e_end
    ldi  R_TEMP_H,      e_temp_address
    rcall EEPROM_WRITE_BYTE

    M_SET_TIMER_1 TIME_1MS
    M_WAIT_TIMER_1

    ret

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_CHECK_ID

    ldi  R_ZP_L,        low(s_identifier)
    ldi  R_ZP_H,        high(s_identifier)

    ld   R_TEMP_L,      Z+
    cpi  R_TEMP_L,      ID_BYTE_1
    brne RFM12BP_ID_ERROR

    ld   R_TEMP_L,      Z+
    cpi  R_TEMP_L,      ID_BYTE_2
    brne RFM12BP_ID_ERROR

    ld   R_TEMP_L,      Z+
    cpi  R_TEMP_L,      ID_BYTE_3
    brne RFM12BP_ID_ERROR

    ld   R_TEMP_L,      Z
    cpi  R_TEMP_L,      ID_BYTE_4
    brne RFM12BP_ID_ERROR

    rjmp RFM12BP_ID_OK

 RFM12BP_ID_ERROR:
    rjmp NO_ACTION

 RFM12BP_ID_OK:

 .endmacro

;------------------------------------------------

 .macro M_EEPROM_READ_BYTE

; Wait for completion of previous write
 EEPROM_READ_BYTE_WAIT:
    sbic EECR,EEPE
    rjmp EEPROM_READ_BYTE_WAIT

; Set up address in address register
    out  EEARL,         R_TEMP_H
; Start eeprom read by writing EERE
    sbi  EECR,          EERE
; Read data from Data Register
    in   R_TEMP_L,      EEDR

    ret

 .endmacro

;------------------------------------------------

 .macro M_EEPROM_WRITE_BYTE

; Write data to Data Register
    out  EEDR,          R_TEMP_L

; Set up address in address register
    out  EEARL,         R_TEMP_H

    cli
; Write logical one to EEMPE
    sbi  EECR,          EEMPE
; Start eeprom write by setting EEPE
    sbi  EECR,          EEPE
    sei

 EEPROM_WRITE_BYTE_WAIT:
; Wait for completion of previous write
    sbic EECR,          EEPE
    rjmp EEPROM_WRITE_BYTE_WAIT

    ret

 .endmacro

;------------------------------------------------

 .macro M_EEPROM_WRITE_BUFF

; numbers of bytes
    ldi  R_COUNT_L,     low(@0)
    ldi  R_COUNT_H,     high(@0)

; EEPROM address destination
    ldi  R_TEMP_L,      low(@1)

; SRAM address source
    ldi  R_XP_L,        low(@2)
    ldi  R_XP_H,        high(@2)

 RFM12BP_EEPROM_WRITE_LOOP:

 RFM12BP_EEPROM_WRITE_BUFF_WAIT_1:
; Wait for completion of previous write
    sbic EECR,          EEPE
    rjmp RFM12BP_EEPROM_WRITE_BUFF_WAIT_1

; Set up address in address register
    out  EEARL,         R_TEMP_L

; Write data to Data Register
    ld   R_TEMP_H,      X+
    out  EEDR,          R_TEMP_H

    cli
; Write logical one to EEMPE
    sbi  EECR,          EEMPE
; Start eeprom write by setting EEPE
    sbi  EECR,          EEPE
    sei

    inc  R_TEMP_L
    sbiw R_COUNT_L,     1
    brne RFM12BP_EEPROM_WRITE_LOOP

 RFM12BP_EEPROM_WRITE_BUFF_WAIT_2:
; Wait for completion of previous write
    sbic EECR,          EEPE
    rjmp RFM12BP_EEPROM_BUFF_WRITE_WAIT_2

 .endmacro

;------------------------------------------------

 .endif

;------------------------------------------------


