;*** vdi.inc ***;
;------------------------------------------------
; Author: Torsten Knorr
; E-mail: create-soft@freenet.de
; copyright(C) 2016-2017 by Torsten Knorr
;------------------------------------------------

 .ifndef __RFM12BP_VDI__
 .equ    __RFM12BP_VDI__ = 1

 .include "RFM12BP.inc"

;------------------------------------------------
; RFM12BP PIN 15 nINT/VDI -> ATmega48 PD4 PCINT2_20

 .macro M_INIT_PCINT2_20_VDI

    ldi  R_TEMP_L,      (1 << PCIF2)
    out  PCIFR,         R_TEMP_L

    ldi  R_TEMP_L,      (1 << PCIE2)
    sts  PCICR,         R_TEMP_L

    clr  R_TEMP_L
    sts  PCMSK2,        R_TEMP_L

    cbi  STATUS_REG,    VDI_STAT_OK
    cbi  PORTD,         LED_VDI

 .endmacro

;------------------------------------------------
; RFM12BP PIN 15 -> ATmega48 PD4 PCINT20

 .macro M_RFM12BP_PCINT2_20_VDI

    in   RI_SREG,       SREG

    sbic PIND,          PIND4
    rjmp VDI_STAT_SET

    cbi  STATUS_REG,    VDI_STAT_OK
    cbi  PORTD,         LED_VDI
    rjmp VDI_STAT_CLEAR

 VDI_STAT_SET:
    sbi  STATUS_REG,    VDI_STAT_OK
    sbi  PORTD,         LED_VDI

 VDI_STAT_CLEAR:

    out  SREG,          RI_SREG
    reti

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_START_VDI

    ldi  R_TEMP_L,      (1 << PCIF2)
    out  PCIFR,         R_TEMP_L

    ldi  R_TEMP_L,      (1 << PCINT20)
    sts  PCMSK2,        R_TEMP_L

    cbi  STATUS_REG,    VDI_STAT_OK
    cbi  PORTD,         LED_VDI

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_STOP_VDI

    clr  R_TEMP_L
    sts  PCMSK2,        R_TEMP_L

    ldi  R_TEMP_L,      (1 << PCIF2)
    out  PCIFR,         R_TEMP_L

    cbi  STATUS_REG,    VDI_STAT_OK
    cbi  PORTD,         LED_VDI

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_WAIT_BAND_BUSY

    M_SET_TIMER_1 0xFFFF

 RFM12BP_WAIT_BAND_BUSY_LOOP:
    wdr

    M_CHECK_TIMER_1
    rjmp RFM12BP_WAIT_BAND_BUSY_END

    sbic STATUS_REG,    VDI_STAT_OK
    rjmp RFM12BP_WAIT_BAND_BUSY_LOOP

 RFM12BP_WAIT_BAND_BUSY_END:
    M_RFM12BP_STOP_VDI
    cbi  PORTC,         RFM12BP_EN_RX
    M_SPI_MT_CMD (CMD_SET_POWER  | EN_SYNTH  | EN_CRYSTAL | DI_CLK_PIN)

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_WAIT_VDI_LOW

    M_SET_RX_TIMEOUT BYTES_FINALE

 RFM12BP_WAIT_VDI_LOW_LOOP:

    M_CHECK_TIMER_1
    rjmp RFM12BP_WAIT_VDI_LOW_END

    sbic STATUS_REG,    VDI_STAT_OK
    rjmp RFM12BP_WAIT_VDI_LOW_LOOP

 RFM12BP_WAIT_VDI_LOW_END:

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_WAIT_VDI_HIGH

    M_SET_TIMER_1 0xFFFF

 RFM12BP_WAIT_VDI_HIGH_LOOP:

    M_CHECK_TIMER_1
    rjmp NO_ACTION

    sbis STATUS_REG,    VDI_STAT_OK
    rjmp RFM12BP_WAIT_VDI_HIGH_LOOP

 .endmacro

;------------------------------------------------

 .macro M_RFM12BP_CHECK_VDI

    sbis STATUS_REG,    VDI_STAT_OK

 .endmacro

;------------------------------------------------

 .endif

;------------------------------------------------
