/*** DataRequestThreadKeyboard.cc ***/
//------------------------------------------------
// Author: Torsten Knorr
// E-mail: create-soft@freenet.de
// Copyright (c) 2015-2017, Torsten Knorr
//------------------------------------------------

 #include "WeatherStation.h"

//------------------------------------------------

 int  gi_menu;
 BOOL gbo_display_change;

//------------------------------------------------

 int GetKey(void)
    {
    int i_bit_position;
    word w_key;

    while(gby_wait_display);

    do
        {
        w_key = Key_Scan();
        } while(0 == w_key);

    Port_WriteBit(PORT_LED1, LED_ON);
    while(Key_Scan());
    Port_WriteBit(PORT_LED1, LED_OFF);

    i_bit_position = 0;
    while(w_key >> ++i_bit_position);

    return i_bit_position;
    }

//------------------------------------------------

 void MenuChange(void)
    {

    gi_menu = gi_menu + MENU_COUNT;
    gi_menu = gi_menu % MENU_COUNT;

    gbo_display_change = true;

    return;
    }

//------------------------------------------------

 void MenuClock(void)
    {

    if(gbo_display_change)
        {
        SET_DISPLAY_MODE( DISPLAY_CLOCK )
        gbo_display_change = false;
        }

    switch(GetKey())
        {
        case KEY_1:
            InsertSetTime();
            gbo_display_change = true;
            Thread_Delay(200);
            break;

        case KEY_2:
        case KEY_3:
        case KEY_4:
        case KEY_5:
        case KEY_6:
        case KEY_7:
        case KEY_8:
        case KEY_9:
            SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
            break;

        case KEY_0:
            gbo_display_change = true;
            break;

        case KEY_H:
            gi_menu++;
            MenuChange();
            break;

        case KEY_X:
            gi_menu--;
            MenuChange();
            break;

        default:
            SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
            break;
        }

    return;
    }

//------------------------------------------------

 void MenuRFM12BP(void)
    {
    static word w_success;
    static word w_wrong;
    static char ac_msg_success[9] = {79, 75, 58, 32, 32, 32, 32, 32, 0};
    static char ac_msg_wrong[9]   = {69, 82, 58, 32, 32, 32, 32, 32, 0};
    byte by_attempts;


    if(gbo_display_change)
        {
        SET_DISPLAY_MOVE(
            "Menu RFM12BP -- Menu RFM12BP -- Menu RFM",
            "1=Req 2=SetID 3=ExeCmd 4=ExeFunc 5=RTest",
            )
        gbo_display_change = false;
        }

    switch(GetKey())
        {
        case KEY_1:
            by_attempts = 20;
            while(by_attempts--)
                {
                if(DataRequest())
                    {
                    SET_DISPLAY_MSG("Data Req", "-- OK --", 200)
                    Str_Printf(ac_msg_success, "OK:%5u", ++w_success);
                    break;
                    }
                else
                    {
                    SET_DISPLAY_MSG("Data Req", " ERROR! ", 200)
                    Str_Printf(ac_msg_wrong, "ER:%5u", ++w_wrong);
                    }
                }

            SET_DISPLAY_MSG(ac_msg_success, ac_msg_wrong, 200)
            gby_cmd    = 0x00;
            gby_para_1 = 0x00;
            gby_para_2 = 0x00;
            gbo_display_change = true;
            break;

        case KEY_2:
            SET_DISPLAY_INSERT("Identif.", "000-255 ")
            gby_id_byte_4 = (GetDecValue(3) & 0x00FF);
            gbo_display_change = true;
            Thread_Delay(200);
            break;

        case KEY_3:
            InsertExeCmd();
            gbo_display_change = true;
            Thread_Delay(200);
            break;

        case KEY_4:
            InsertExeFunction();
            gbo_display_change = true;
            Thread_Delay(200);
            break;

        case KEY_5:
            while(1)
                {
                if(DataRequest())
                    {
                    SET_DISPLAY_MSG("Data Req", "-- OK --", 200)
                    Str_Printf(ac_msg_success, "OK:%5u", ++w_success);
                    }
                else
                    {
                    SET_DISPLAY_MSG("Data Req", " ERROR! ", 200)
                    Str_Printf(ac_msg_wrong, "ER:%5u", ++w_wrong);
                    }
                SET_DISPLAY_MSG(ac_msg_success, ac_msg_wrong, 200)
                SET_DISPLAY_MSG("To Break", "Hold Key", 200)
                if(Key_Scan())
                    break;
                }

            Port_WriteBit(PORT_LED1, LED_ON);
            while(Key_Scan());
            Port_WriteBit(PORT_LED1, LED_OFF);

            gby_cmd    = 0x00;
            gby_para_1 = 0x00;
            gby_para_2 = 0x00;
            gbo_display_change = true;
            break;

        case KEY_6:
        case KEY_7:
        case KEY_8:
        case KEY_9:
            SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
            break;

        case KEY_0:
            gbo_display_change = true;
            break;

        case KEY_H:
            gi_menu++;
            MenuChange();
            break;

        case KEY_X:
            gi_menu--;
            MenuChange();
            break;

        default:
            SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
            break;
        }

    return;
    }

//------------------------------------------------

 void MenuSetPara(void)
    {

    if(gbo_display_change)
        {
        SET_DISPLAY_MOVE(
            "Menu Set RX TX Filter Parameter ",
            "1=O1 2=O2 3=H1 4=H2 5=BBW 6=G 7=DI 8=DQD",
            )
        gbo_display_change = false;
        }

    gby_cmd    = 0x00;
    gby_para_1 = 0x00;
    gby_para_2 = 0x00;
    switch(GetKey())
        {
        case KEY_1:
            SetOutputPower1();
            break;

        case KEY_2:
            SetOutputPower2();
            break;

        case KEY_3:
            SetDeviation1();
            break;

        case KEY_4:
            SetDeviation2();
            break;

        case KEY_5:
            SetBasebandWidth();
            break;

        case KEY_6:
            SetLNAGain();
            break;

        case KEY_7:
            SetDRSSI();
            break;

        case KEY_8:
            SetDQD();
            break;

        case KEY_9:
            SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
            break;

        case KEY_0:
            gbo_display_change = true;
            break;

        case KEY_H:
            gi_menu++;
            MenuChange();
            break;

        case KEY_X:
            gi_menu--;
            MenuChange();
            break;

        default:
            SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
            break;
        }

    return;
    }

//------------------------------------------------

 void MenuValuesTemp(void)
    {

    if(gbo_display_change)
        {
        SET_DISPLAY_MOVE(
            "Menu Temperature Values",
            "1=T.Out 2=T.In 3=T.E10 4=T.E20"
            )
        gbo_display_change = false;
        }

    switch(GetKey())
        {
        case KEY_1:
            SET_DISPLAY_VALUE("Temp Out", RFM12BP_TEMP_OUTSIDE)
            break;

        case KEY_2:
            SET_DISPLAY_VALUE("Temp In ", RFM12BP_TEMP_INSIDE)
            break;

        case KEY_3:
            SET_DISPLAY_VALUE("Temp E10", RFM12BP_TEMP_EARTH_10)
            break;

        case KEY_4:
            SET_DISPLAY_VALUE("Temp E20", RFM12BP_TEMP_EARTH_20)
            break;

        case KEY_5:
        case KEY_6:
        case KEY_7:
        case KEY_8:
        case KEY_9:
            SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
            break;

        case KEY_0:
            gbo_display_change = true;
            break;

        case KEY_H:
            gi_menu++;
            MenuChange();
            break;

        case KEY_X:
            gi_menu--;
            MenuChange();
            break;

        default:
            SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
            break;
        }

    return;
    }

//------------------------------------------------

 void MenuValuesHum(void)
    {

    if(gbo_display_change)
        {
        SET_DISPLAY_MOVE(
            "Menu Humidity Values",
            "1=Rain 2=Level 3=Gr.Mo 4=H.out 5=H.in"
            )
        gbo_display_change = false;
        }

    switch(GetKey())
        {
        case KEY_1:
            SET_DISPLAY_VALUE("Rainfall", RFM12BP_RAINFALL)
            break;

        case KEY_2:
            SET_DISPLAY_VALUE(" Level  ", RFM12BP_LEVEL)
            break;

        case KEY_3:
            SET_DISPLAY_VALUE("GroundMo", RFM12BP_GROUND_MOISTURE)
            break;

        case KEY_4:
            SET_DISPLAY_VALUE("Hum Out ", RFM12BP_HUMIDITY_OUTSIDE)
            break;

        case KEY_5:
            SET_DISPLAY_VALUE("Hum In  ", RFM12BP_HUMIDITY_INSIDE)
            break;

        case KEY_6:
        case KEY_7:
        case KEY_8:
        case KEY_9:
            SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
            break;

        case KEY_0:
            gbo_display_change = true;
            break;

        case KEY_H:
            gi_menu++;
            MenuChange();
            break;

        case KEY_X:
            gi_menu--;
            MenuChange();
            break;

        default:
            SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
            break;
        }

    return;
    }

//------------------------------------------------

 void MenuValuesAir(void)
    {

    if(gbo_display_change)
        {
        SET_DISPLAY_MOVE(
            "Menu Air Values -- Menu Air Values",
            "1=Pressure 2=Wind Force 3=Wind Direction"
            )
        gbo_display_change = false;
        }

    switch(GetKey())
        {
        case KEY_1:
            SET_DISPLAY_VALUE("Pressure", RFM12BP_PRESSURE)
            break;

        case KEY_2:
            SET_DISPLAY_VALUE("WinForce", RFM12BP_WIND_FORCE)
            break;

        case KEY_3:
            SET_DISPLAY_VALUE("WinDirec", RFM12BP_WIND_DIRECTION)
            break;

        case KEY_4:
        case KEY_5:
        case KEY_6:
        case KEY_7:
        case KEY_8:
        case KEY_9:
            SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
            break;

        case KEY_0:
            gbo_display_change = true;
            break;

        case KEY_H:
            gi_menu++;
            MenuChange();
            break;

        case KEY_X:
            gi_menu--;
            MenuChange();
            break;

        default:
            SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
            break;
        }

    return;
    }

//------------------------------------------------

 void MenuState(void)
    {

    if(gbo_display_change)
        {
        SET_DISPLAY_MOVE(
            "Menu State -- Menu State -- Menu State",
            "1=OpHours 2=FroStop 3=ERRCount 4=I2C ERR"
            )
        gbo_display_change = false;
        }

    switch(GetKey())
        {
        case KEY_1:
            SET_DISPLAY_VALUE("Op Hours", RFM12BP_OPERATION_HOURS)
            break;

        case KEY_2:
            SET_DISPLAY_VALUE("Fro Stop", RFM12BP_RAINFALL_FR_STOP)
            break;

        case KEY_3:
            SET_DISPLAY_VALUE("ERRCount", RFM12BP_ERRORS_COUNT)
            break;

        case KEY_4:
            SET_DISPLAY_VALUE("I2C ERR ", RFM12BP_I2C_ERRORS )
            break;

        case KEY_5:
        case KEY_6:
        case KEY_7:
        case KEY_8:
        case KEY_9:
            SET_DISPLAY_ERROR(DISPLAY_UNDEF_KEY, 200)
            break;

        case KEY_0:
            gbo_display_change = true;
            break;

        case KEY_H:
            gi_menu++;
            MenuChange();
            break;

        case KEY_X:
            gi_menu--;
            MenuChange();
            break;

        default:
            SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
            break;
        }

    return;
    }

//------------------------------------------------

 void ThreadKeyboard(void)
    {

    while(1)
        {
        switch(gi_menu)
            {
            case MENU_CLOCK:
                MenuClock();
                break;

            case MENU_RFM12BP:
                MenuRFM12BP();
                break;

            case MENU_SET_PARA:
                MenuSetPara();
                break;

            case MENU_VALUES_TEMP:
                MenuValuesTemp();
                break;

            case MENU_VALUES_HUM:
                MenuValuesHum();
                break;

            case MENU_VALUES_AIR:
                MenuValuesAir();
                break;

            case MENU_STATE:
                MenuState();
                break;

            default:
                SET_DISPLAY_ERROR(DISPLAY_OUT_OF_RANGE, 200)
                break;
            }
        }

    return;
    }

//------------------------------------------------